ru.bitel.bgbilling.kernel.contract.balance.common.bean

## Class BalanceDetailItem

- java.lang.Object
- - ru.bitel.bgbilling.kernel.contract.balance.common.bean.BalanceDetailItem

- All Implemented Interfaces:
    java.lang.Comparable<BalanceDetailItem>

      public class BalanceDetailItem
      extends java.lang.Object
      implements java.lang.Comparable<BalanceDetailItem>

  Bean впервую очередь для таблицы "Детализированный баланс"(элементы дерева баланса: исходящий остаток, доступная сумма).
  Author:
    ildar

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `TYPE_ACCOUNT`
    `static int` | `TYPE_CHARGE`
    `static int` | `TYPE_END_MONTH`
    `static int` | `TYPE_PAYBACK`
    `static int` | `TYPE_PAYMENT`
    `static int` | `TYPE_RESERVE_CLOSE`
    `static int` | `TYPE_RESERVE_CREATE`
    `static int` | `TYPE_START_MONTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BalanceDetailItem()`
    `BalanceDetailItem(Charge charge, java.lang.String contractTitle, java.lang.String typeTitle)`
    `BalanceDetailItem(ContractAccount account, java.lang.String contractTitle, java.lang.String serviceTitle)`
    `BalanceDetailItem(int type, java.util.Date date, java.math.BigDecimal sumAfterChange)` Конструктор для элементов начала и конца месяца.
    `BalanceDetailItem(Payment payment, java.lang.String contractTitle, java.lang.String typeTitle)`
    `BalanceDetailItem(Reserve reserve, int type, java.lang.String contractTitle, java.lang.String typeTitle)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compareTo(BalanceDetailItem o)`
    `java.lang.String` | `getComment()`
    `java.lang.String` | `getContractTitle()`
    `java.util.Date` | `getDate()`
    `java.math.BigDecimal` | `getSum()` Приходы и закрытые резервы имеют положительную сумму, остольные с отрицательным значением.
    `java.math.BigDecimal` | `getSumAfterChange()`
    `java.lang.String` | `getTitle()`
    `int` | `getType()`
    `java.lang.String` | `getTypeTitle()`
    `void` | `setComment(java.lang.String comment)`
    `void` | `setContractTitle(java.lang.String contractTitle)`
    `void` | `setDate(java.util.Date date)`
    `void` | `setSum(java.math.BigDecimal sum)` Приходы и закрытые резервы имеют положительную сумму, остольные с отрицательным значением.
    `void` | `setSumAfterChange(java.math.BigDecimal sumAfterChange)`
    `void` | `setTitle(java.lang.String title)`
    `void` | `setType(int type)`
    `java.math.BigDecimal` | `toSetSumAfterChange(java.math.BigDecimal sumBeforChange)` В зависемости от типа либо прибавит либо убавит на свою сумму, после чего установит sumAfterChange и вернет ее же.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### TYPE_PAYMENT

          public static final int TYPE_PAYMENT

      See Also:
        Constant Field Values

    - #### TYPE_CHARGE

          public static final int TYPE_CHARGE

      See Also:
        Constant Field Values

    - #### TYPE_PAYBACK

          public static final int TYPE_PAYBACK

      See Also:
        Constant Field Values

    - #### TYPE_ACCOUNT

          public static final int TYPE_ACCOUNT

      See Also:
        Constant Field Values

    - #### TYPE_RESERVE_CREATE

          public static final int TYPE_RESERVE_CREATE

      See Also:
        Constant Field Values

    - #### TYPE_RESERVE_CLOSE

          public static final int TYPE_RESERVE_CLOSE

      See Also:
        Constant Field Values

    - #### TYPE_START_MONTH

          public static final int TYPE_START_MONTH

      See Also:
        Constant Field Values

    - #### TYPE_END_MONTH

          public static final int TYPE_END_MONTH

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### BalanceDetailItem

          public BalanceDetailItem()

    - #### BalanceDetailItem

          public BalanceDetailItem(int type,
                                   java.util.Date date,
                                   java.math.BigDecimal sumAfterChange)

      Конструктор для элементов начала и конца месяца.

    - #### BalanceDetailItem

          public BalanceDetailItem(Payment payment,
                                   java.lang.String contractTitle,
                                   java.lang.String typeTitle)

    - #### BalanceDetailItem

          public BalanceDetailItem(Charge charge,
                                   java.lang.String contractTitle,
                                   java.lang.String typeTitle)

    - #### BalanceDetailItem

          public BalanceDetailItem(Reserve reserve,
                                   int type,
                                   java.lang.String contractTitle,
                                   java.lang.String typeTitle)

      Parameters:
        `type` - - тип операции резерва, открытие или закрытие(из статик полей).

    - #### BalanceDetailItem

          public BalanceDetailItem(ContractAccount account,
                                   java.lang.String contractTitle,
                                   java.lang.String serviceTitle)

  - ### Method Detail

    - #### compareTo

          public int compareTo(BalanceDetailItem o)

      Specified by:
        `compareTo` in interface `java.lang.Comparable<BalanceDetailItem>`

    - #### getTypeTitle

          public java.lang.String getTypeTitle()

    - #### getDate

          public java.util.Date getDate()

    - #### setDate

          public void setDate(java.util.Date date)

    - #### getTitle

          public java.lang.String getTitle()

    - #### setTitle

          public void setTitle(java.lang.String title)

    - #### getSum

          public java.math.BigDecimal getSum()

      Приходы и закрытые резервы имеют положительную сумму, остольные с отрицательным значением.

    - #### setSum

          public void setSum(java.math.BigDecimal sum)

      Приходы и закрытые резервы имеют положительную сумму, остольные с отрицательным значением.

    - #### getComment

          public java.lang.String getComment()

    - #### setComment

          public void setComment(java.lang.String comment)

    - #### getContractTitle

          public java.lang.String getContractTitle()

    - #### setContractTitle

          public void setContractTitle(java.lang.String contractTitle)

    - #### setType

          public void setType(int type)

    - #### getType

          public int getType()

    - #### getSumAfterChange

          public java.math.BigDecimal getSumAfterChange()

    - #### setSumAfterChange

          public void setSumAfterChange(java.math.BigDecimal sumAfterChange)

    - #### toSetSumAfterChange

          public java.math.BigDecimal toSetSumAfterChange(java.math.BigDecimal sumBeforChange)

      В зависемости от типа либо прибавит либо убавит на свою сумму, после чего установит sumAfterChange и вернет ее же.
      Parameters:
        `sumBeforChange` - - сумма от которой будет расчитываться sumAfterChange, то есть та сумма которая была до этого прихода/расхода/наработки/резерва.